/* Use methods named '__str__' to supply string representations of objects. */
%rename __str__ toString;

%rename("%(lowercamelcase)s", %$ismember) "";

%include "enumtypeunsafe.swg"
%javaconst(1);

/*
 * Support string arrays as char ** input arguments.
 */
%typemap(in, numinputs=1, noblock=1) (const char **channel_names, size_t count_channels) (jstring *jstrings) {
	size_t count_channels = JCALL1(GetArrayLength, jenv, $input);
	$2 = count_channels;
	$1 = (char **) calloc($2 + 1, sizeof(char *));
	jstrings = calloc($2 + 1, sizeof(jstring));
	{
		size_t i;
		for (i = 0; i < $2; i ++) {
			jstrings[i] = (jstring) JCALL2(GetObjectArrayElement, jenv, $input, (jsize) i);
			$1[i] = (char *) JCALL2(GetStringUTFChars, jenv, jstrings[i], 0);
		}
	}
}

%typemap(freearg, noblock=1) (const char **channel_names, size_t count_channels) {
	{
		size_t i;
		for (i = 0; i < $2; i ++)
		{
			JCALL2(ReleaseStringUTFChars, jenv, jstrings$argnum[i], $1[i]);
			JCALL1(DeleteLocalRef, jenv, jstrings$argnum[i]);
		}
	}
	free(jstrings$argnum);
	jstrings$argnum = NULL;
	free($1);
	$1 = NULL;
}

%typemap(jni) char ** "jobjectArray";
%typemap(jtype) char ** "String[]";
%typemap(jstype) char ** "String[]";

%typemap(javain) char ** "$javainput";
%typemap(javaout) char ** {
	$jnicall;
}

/**
 * Support nds_buffer arrays as buffer ** output arguments in Java.
 */

%typemap(jni) nds_buffer ** "jobject";
%typemap(jtype) nds_buffer ** "buffer[]";
%typemap(jstype) nds_buffer ** "buffer[]";

%typemap(javain) nds_buffer ** "$javainput";
%typemap(javaout) nds_buffer ** {
	return $jnicall;
}

/**
 * Support nds_channel and nds_buffer arrays double-pointer return values.
 */

%typemap(jni) SWIGTYPE ** "jobject";
%typemap(jtype) SWIGTYPE ** "$typemap(jstype, $*1_type)[]";
%typemap(jstype) SWIGTYPE ** "$typemap(jstype, $*1_type)[]";

%typemap(javain) SWIGTYPE ** "$javainput";
%typemap(javaout) SWIGTYPE ** {
	return $jnicall;
}

%typemap(in, numinputs=0, noblock=1) size_t *count_channels {
	size_t count_channels;
	$1 = &count_channels;
}

%typemap(out) SWIGTYPE ** {
	/* Locate channel class. */
	static jclass clazz = NULL;
	if (!clazz)
	{
        /* FIXME: FindClass requires the fully qualified class name, but typemap(jstype)
         * doesn't give us the package.  Is there a way to discover the fully qualified
         * name of the channel or buffer class, instead of hard coding the package name?
         */
		jclass local_clazz = JCALL1(FindClass, jenv, "nds/$typemap(jstype, $*1_type)");
		clazz = (jclass) JCALL1(NewGlobalRef, jenv, (jobject) local_clazz);
		JCALL1(DeleteLocalRef, jenv, (jobject) local_clazz);
	}

	static jmethodID ctor = NULL;
	if (!ctor)
	{
		jmethodID local_ctor = JCALL3(GetMethodID, jenv, clazz, "<init>", "(JZ)V");
		ctor = (jmethodID) JCALL1(NewGlobalRef, jenv, (jobject) local_ctor);
		JCALL1(DeleteLocalRef, jenv, (jobject) local_ctor);
	}

	/* Create reference to null. */
	static jobject nil = NULL;
	if (!nil)
	{
		jobject local = JCALL1(NewGlobalRef, jenv, NULL);
	}

	/* Initialize the array with the specified length, with each entry being null. */
	$result = JCALL3(NewObjectArray, jenv, (jsize) (jsize) count_channels, clazz, nil);
	{
		size_t i;
		for (i = 0; i < count_channels; i ++)
		{
			$typemap(jni, $*1_type) ctor_arg1 = (long) $1[i];
			jboolean ctor_arg2 = JNI_TRUE;
			jobject obj = JCALL4(NewObject, jenv, clazz, ctor, ctor_arg1, ctor_arg2);
			JCALL3(SetObjectArrayElement, jenv, $result, (jsize) i, obj);
			JCALL1(DeleteLocalRef, jenv, obj);
		}
	}
}

%typemap(newfree, noblock=1) SWIGTYPE ** {
	free($1);
}

%apply SWIGTYPE ** {nds_channel **, nds_buffer **};

/**
 * Make buffer.getChannel return a copy.
 */

%typemap(javaout) nds_channel * {
	return new $javaclassname($jnicall, true);
}
%typemap(out, noblock=1) nds_channel (nds_channel *channel) {
	channel = (nds_channel *) calloc(1, sizeof(nds_channel));
	*channel = $1;
	$result = channel;
}

/**
 * Support getting numeric arrays from unsigned char[] using polymorphism.
 */

%typemap(jni) unsigned char [] "jobject";
%typemap(jtype) unsigned char [] "Object";
%typemap(jstype) unsigned char [] "Object";

%typemap(javain) unsigned char [] "$javainput";
%typemap(javaout) unsigned char [] {
	return $jnicall;
}

%typemap(out, noblock=1) unsigned char [] {
	switch (arg1->channel.data_type)
	{
		case NDS_DATA_TYPE_INT16:
			$result = JCALL1(NewShortArray, jenv, (jsize) arg1->length);
			JCALL4(SetShortArrayRegion, jenv, $result, 0, (jsize) arg1->length, (jshort *) $1);
			break;
		case NDS_DATA_TYPE_INT32:
			$result = JCALL1(NewIntArray, jenv, (jsize) arg1->length);
			JCALL4(SetIntArrayRegion, jenv, $result, 0, (jsize) arg1->length, (jint *) $1);
			break;
		case NDS_DATA_TYPE_INT64:
			$result = JCALL1(NewLongArray, jenv, (jsize) arg1->length);
			JCALL4(SetLongArrayRegion, jenv, $result, 0, (jsize) arg1->length, (jlong *) $1);
			break;
		case NDS_DATA_TYPE_FLOAT32:
			$result = JCALL1(NewFloatArray, jenv, (jsize) arg1->length);
			JCALL4(SetFloatArrayRegion, jenv, $result, 0, (jsize) arg1->length, (jfloat *) $1);
			break;
		case NDS_DATA_TYPE_FLOAT64:
			$result = JCALL1(NewDoubleArray, jenv, (jsize) arg1->length);
			JCALL4(SetDoubleArrayRegion, jenv, $result, 0, (jsize) arg1->length, (jdouble *) $1);
			break;
		case NDS_DATA_TYPE_COMPLEX32:
			SWIG_exception(SWIG_TypeError, "Java does not have a native complex type");
			break;
		default:
			SWIG_exception(SWIG_TypeError, "Unknown NDS data type");
			break;
	}
}

/**
 * Everything below is relevant to MATLAB only.
 * A JAR that is intended for use directly from Java code would make more sense
 * without what follows.  (Note: I'm thinking of creating a separate directory
 * under swig/ for matlab, and creating one JAR for Java and one specifically
 * for Java under MATLAB.
 *
 * MATLAB does not automatically convert java.lang.String return values to its
 * own char arrays, so for convenient calling from MATLAB we turn C strings into
 * double-scripted char arrays, which MATLAB knows to interpret as its own char
 * arrays.
 *
 * Note that MATLAB does seem to know how to convert char arrays into
 * java.lang.String input arguments, so the input typemap could be disabled.
 */

%typemap(jni) CSTRINGTYPE "jobjectArray";
%typemap(jtype) CSTRINGTYPE "char[][]";
%typemap(jstype) CSTRINGTYPE "char[][]";

%typemap(javain) CSTRINGTYPE "$javainput";
%typemap(javaout) CSTRINGTYPE {
	return $jnicall;
}

%typemap(out) CSTRINGTYPE {
	/* Look up the class for an array of chars (char []). */
	static jclass clazz = NULL;
	if (!clazz)
	{
		jclass local_clazz = JCALL1(FindClass, jenv, "[C");
		clazz = (jclass) JCALL1(NewGlobalRef, jenv, (jobject) local_clazz);
		JCALL1(DeleteLocalRef, jenv, (jobject) local_clazz);
	}

	/* Create a new inner array -- which will store the chars in the string. */
	const jsize len = strlen($1);
	jcharArray innerArray = JCALL1(NewCharArray, jenv, len);

	/* Since a Java char is 16 bits wide, and in most C compilers a char is
	 * 8 bits wide, it's safest to copy the chars over byte by byte. */

	/* Get a pointer to the underlying array data. */
	jchar *innerArrayChars = JCALL2(GetCharArrayElements, jenv, innerArray, NULL);

	/* Copy character-for-character. */
	int i;
	for (i = 0; i < len; i ++)
		innerArrayChars[i] = $1[i];

	/* Release the array data, causing a copy if necessary. */
	JCALL3(ReleaseCharArrayElements, jenv, innerArray, innerArrayChars, 0);

	/* Create a new array of char[] (a char[][]). */
	$result = JCALL3(NewObjectArray, jenv, 1, clazz, (jobject) innerArray);

	/* Let go of innerArray. (GC will do this for us, but let's be tidy.) */
	JCALL1(DeleteLocalRef, jenv, (jobject) innerArray);
}

%typemap(in) CSTRINGTYPE {
	/* Get inner array */
	/* FIXME: what to do if this exceeds bounds? What if innerArray is Null? */
	jcharArray innerArray = (jcharArray) JCALL2(GetObjectArrayElement, jenv, $input, 0);

	/* Get string length */
	jsize len = JCALL1(GetArrayLength, jenv, innerArray);

	/* Create char array to store converted string */
	$1 = malloc(sizeof($*1_type) * (len + 1));

	/* Since a Java char is 16 bits wide, and in most C compilers a char is
	 * 8 bits wide, it's safest to copy the chars over byte by byte. */

	/* Get a pointer to the underlying array data. */
	jchar *innerArrayChars = JCALL2(GetCharArrayElements, jenv, innerArray, NULL);

	/* Copy character-for-character. */
	int i;
	for (i = 0; i < len; i ++)
		$1[i] = innerArrayChars[i];

	/* Append C string terminator */
	$1[i] = '\0';

	/* Release the array data. */
	JCALL3(ReleaseCharArrayElements, jenv, innerArray, innerArrayChars, JNI_ABORT);

	/* Let go of innerArray. (GC will do this for us, but let's be tidy.) */
	JCALL1(DeleteLocalRef, jenv, (jobject) innerArray);
}

%typemap(freearg, noblock=1) CSTRINGTYPE {
	free($1);
}

%apply CSTRINGTYPE {char *, char[255]};
