% Import module
nds;

% Open connection and print some information about the server
conn = nds.connection('llocds.ligo-la.caltech.edu', 31200);
disp('Connection:'); disp(conn);
disp(sprintf('Host: %s', conn.get_host()));
disp(sprintf('Port: %d', conn.get_port()));
disp(sprintf('Protocol: %d', conn.get_protocol()));

% Get list of available channels and print some information about them
channels = conn.find_channels();
disp(sprintf('Channels: %d', length(channels)));
disp('First channel:'); disp(channels{1});
disp(sprintf('First channel name: %s', channels{1}.name));

% Fetch some data
data = conn.fetch(1018376019, 1018376030, ...
    {'L1:PEM-EY_SEISX_OUT_DQ', 'L1:PEM-EY_SEISY_OUT_DQ', 'L1:PEM-EY_SEISZ_OUT_DQ'});
disp('A buffer:'); disp(data{1});
disp('Its data:'); disp(data{1}.data);
disp('Its channel:'); disp(data{1}.channel);
